/* Copyright (C) 1991, 1992 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#include <hurd.h>

int
setdtablesize (int size)
{
  int i;
  __typeof (_hurd_dtable.d) table;

  __mutex_lock (&_hurd_dtable_lock);

  for (i = size; i < _hurd_dtable.size; ++i)
    if (_hurd_dtable.d[i].server != MACH_PORT_NULL)
      {
	__mutex_unlock (&_hurd_dtable_lock);
	errno = EBUSY;
	return -1;
      }

  table = realloc (_hurd_dtable.d, size * sizeof (*table));
  if (table == NULL)
    {
      __mutex_unlock (&_hurd_dtable_lock);
      return -1;
    }

  for (i = _hurd_dtable.size; i < size; ++i)
    table[i].server = MACH_PORT_NULL;

  _hurd_dtable.size = size;
  _hurd_dtable.d = table;
  __mutex_unlock (&_hurd_dtable_lock);
  return 0;
}
