
/*  A Bison parser, made from pic.y  */

#define	LABEL	258
#define	VARIABLE	259
#define	NUMBER	260
#define	TEXT	261
#define	COMMAND	262
#define	DELIMITED	263
#define	ORDINAL	264
#define	LEFT_ARROW_HEAD	265
#define	RIGHT_ARROW_HEAD	266
#define	DOUBLE_ARROW_HEAD	267
#define	LAST	268
#define	UP	269
#define	DOWN	270
#define	LEFT	271
#define	RIGHT	272
#define	BOX	273
#define	CIRCLE	274
#define	ELLIPSE	275
#define	ARC	276
#define	LINE	277
#define	ARROW	278
#define	MOVE	279
#define	SPLINE	280
#define	HEIGHT	281
#define	RADIUS	282
#define	WIDTH	283
#define	DIAMETER	284
#define	FROM	285
#define	TO	286
#define	AT	287
#define	WITH	288
#define	BY	289
#define	THEN	290
#define	DOTTED	291
#define	DASHED	292
#define	CHOP	293
#define	SAME	294
#define	INVISIBLE	295
#define	LJUST	296
#define	RJUST	297
#define	ABOVE	298
#define	BELOW	299
#define	OF	300
#define	THE	301
#define	WAY	302
#define	BETWEEN	303
#define	AND	304
#define	HERE	305
#define	DOT_N	306
#define	DOT_E	307
#define	DOT_W	308
#define	DOT_S	309
#define	DOT_NE	310
#define	DOT_SE	311
#define	DOT_NW	312
#define	DOT_SW	313
#define	DOT_C	314
#define	DOT_START	315
#define	DOT_END	316
#define	DOT_X	317
#define	DOT_Y	318
#define	DOT_HT	319
#define	DOT_WID	320
#define	DOT_RAD	321
#define	SIN	322
#define	COS	323
#define	ATAN2	324
#define	LOG	325
#define	EXP	326
#define	SQRT	327
#define	MAX	328
#define	MIN	329
#define	INT	330
#define	RAND	331
#define	COPY	332
#define	THRU	333
#define	TOP	334
#define	BOTTOM	335
#define	UPPER	336
#define	LOWER	337
#define	SH	338
#define	PRINT	339
#define	CW	340
#define	CCW	341
#define	FOR	342
#define	DO	343
#define	IF	344
#define	ELSE	345
#define	ANDAND	346
#define	OROR	347
#define	NOTEQUAL	348
#define	EQUALEQUAL	349
#define	LESSEQUAL	350
#define	GREATEREQUAL	351
#define	LEFT_CORNER	352
#define	RIGHT_CORNER	353
#define	CENTER	354
#define	END	355
#define	START	356
#define	RESET	357
#define	UNTIL	358
#define	PLOT	359
#define	THICKNESS	360
#define	FILL	361
#define	ALIGNED	362
#define	SPRINTF	363
#define	DEFINE	364
#define	UNDEF	365

#line 19 "pic.y"

#include "pic.h"
#include "ptable.h"
#include "object.h"

extern int delim_flag;
extern void do_copy(const char *);
extern void copy_rest_thru(const char *, const char *);
extern void copy_file_thru(const char *, const char *, const char *);
extern void push_body(const char *);
extern void do_for(char *var, double from, double to,
		   int by_is_multiplicative, double by, char *body);
extern void do_lookahead();

extern "C" {
  double fmod(double, double);
  int rand();
}

#ifndef __BORLANDC__
#define YYDEBUG 1
#endif /* __BORLANDC__ */

int yylex();
void yyerror(const char *);

void reset(const char *nm);
void reset_all();

place *lookup_label(const char *);
void define_label(const char *label, const place *pl);

direction current_direction;
position current_position;

implement_ptable(place)

PTABLE(place) top_table;

PTABLE(place) *current_table = &top_table;
saved_state *current_saved_state = 0;

object_list olist;

const char *ordinal_postfix(int n);
const char *object_type_name(object_type type);
char *format_number(const char *form, double n);
char *do_sprintf(const char *form, const double *v, int nv);


#line 71 "pic.y"
typedef union {
	char *str;
	int n;
	double x;
	struct { double x, y; } pair;
	struct { double x; char *body; } if_data;
	struct { char *str; const char *filename; int lineno; } lstr;
	struct { double *v; int nv; int maxv; } dv;
	struct { double val; int is_multiplicative; } by;
	place pl;
	object *obj;
	corner crn;
	path *pth;
	object_spec *spec;
	saved_state *pstate;
	graphics_state state;
	object_type obtype;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __STDC__
#define const
#endif



#define	YYFINAL		376
#define	YYFLAG		-32768
#define	YYNTBASE	131

#define YYTRANSLATE(x) ((unsigned)(x) <= 365 ? yytranslate[x] : 172)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   120,     2,     2,     2,   119,     2,     2,   111,
   129,   117,   115,   112,   116,   130,   118,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   124,   122,   113,
   123,   114,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   127,     2,   128,   121,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   125,     2,   126,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110
};

static const short yyprhs[] = {     0,
     0,     2,     4,     8,    10,    14,    15,    17,    19,    22,
    26,    28,    30,    32,    34,    36,    39,    42,    45,    46,
    50,    53,    54,    55,    63,    64,    65,    72,    73,    84,
    86,    87,    92,    94,    96,    99,   102,   106,   107,   113,
   114,   117,   119,   123,   127,   128,   131,   135,   137,   142,
   147,   152,   153,   154,   161,   163,   164,   166,   168,   170,
   172,   174,   176,   178,   180,   182,   184,   187,   191,   192,
   197,   201,   205,   209,   213,   216,   219,   223,   226,   230,
   233,   237,   240,   244,   248,   252,   256,   260,   264,   267,
   270,   274,   277,   281,   284,   288,   291,   295,   298,   301,
   304,   307,   310,   313,   316,   319,   322,   325,   328,   331,
   335,   338,   340,   346,   347,   351,   353,   355,   357,   361,
   365,   371,   377,   384,   386,   391,   395,   399,   401,   404,
   407,   411,   413,   415,   417,   421,   423,   426,   429,   432,
   434,   436,   438,   440,   442,   444,   446,   449,   451,   454,
   458,   460,   462,   465,   467,   472,   476,   480,   483,   485,
   487,   489,   491,   493,   495,   497,   499,   501,   503,   505,
   507,   509,   511,   513,   516,   519,   522,   525,   527,   529,
   532,   535,   538,   541,   543,   545,   547,   549,   551,   554,
   557,   560,   563,   566,   570,   574,   578,   582,   586,   590,
   593,   597,   602,   607,   614,   619,   624,   629,   636,   643,
   648,   653,   657,   661,   665,   669,   673,   677,   681,   685,
   689
};

static const short yyrhs[] = {   134,
     0,   132,     0,   134,   133,   134,     0,   150,     0,   133,
   135,   150,     0,     0,   135,     0,   122,     0,   135,   122,
     0,     4,   123,   148,     0,    14,     0,    15,     0,    16,
     0,    17,     0,     7,     0,    84,   171,     0,    84,   156,
     0,    84,   158,     0,     0,    83,   137,     8,     0,    77,
     6,     0,     0,     0,    77,     6,    78,   138,     8,   139,
   147,     0,     0,     0,    77,    78,   140,     8,   141,   147,
     0,     0,    87,     4,   123,   171,    31,   171,   149,    88,
   142,     8,     0,   145,     0,     0,   145,    90,   143,     8,
     0,   144,     0,   102,     0,   102,     4,     0,   144,     4,
     0,   144,   112,     4,     0,     0,    89,   148,    35,   146,
     8,     0,     0,   103,     6,     0,   171,     0,   156,    94,
   156,     0,   156,    93,   156,     0,     0,    34,   171,     0,
    34,   117,   171,     0,   154,     0,     3,   124,   134,   150,
     0,     3,   124,   134,   159,     0,     3,   124,   134,   162,
     0,     0,     0,   125,   151,   132,   126,   152,   153,     0,
   136,     0,     0,   150,     0,    18,     0,    19,     0,    20,
     0,    21,     0,    22,     0,    23,     0,    24,     0,    25,
     0,   156,     0,   104,   171,     0,   104,   171,   156,     0,
     0,   127,   155,   132,   128,     0,   154,    26,   171,     0,
   154,    27,   171,     0,   154,    28,   171,     0,   154,    29,
   171,     0,   154,   171,     0,   154,    14,     0,   154,    14,
   171,     0,   154,    15,     0,   154,    15,   171,     0,   154,
    17,     0,   154,    17,   171,     0,   154,    16,     0,   154,
    16,   171,     0,   154,    30,   158,     0,   154,    31,   158,
     0,   154,    32,   158,     0,   154,    33,   169,     0,   154,
    34,   161,     0,   154,    35,     0,   154,    36,     0,   154,
    36,   171,     0,   154,    37,     0,   154,    37,   171,     0,
   154,   106,     0,   154,   106,   171,     0,   154,    38,     0,
   154,    38,   171,     0,   154,    39,     0,   154,    40,     0,
   154,    10,     0,   154,    11,     0,   154,    12,     0,   154,
    85,     0,   154,    86,     0,   154,   156,     0,   154,    41,
     0,   154,    42,     0,   154,    43,     0,   154,    44,     0,
   154,   105,   171,     0,   154,   107,     0,     6,     0,   108,
   111,     6,   157,   129,     0,     0,   157,   112,   171,     0,
   159,     0,   162,     0,   161,     0,   158,   115,   161,     0,
   158,   116,   161,     0,   111,   158,   112,   158,   129,     0,
   171,   160,   158,    49,   158,     0,   171,   113,   158,   112,
   158,   114,     0,    48,     0,    45,    46,    47,    48,     0,
   171,   112,   171,     0,   111,   161,   129,     0,   163,     0,
   163,   170,     0,   170,   163,     0,   170,    45,   163,     0,
    50,     0,     3,     0,   165,     0,   163,   130,     3,     0,
    13,     0,     9,    13,     0,     9,   166,     0,   164,   166,
     0,    18,     0,    19,     0,    20,     0,    21,     0,    22,
     0,    23,     0,    25,     0,   127,   128,     0,     6,     0,
   130,     3,     0,   167,   130,     3,     0,   170,     0,   167,
     0,   167,   170,     0,   168,     0,     9,    13,   166,   168,
     0,    13,   166,   168,     0,     9,   166,   168,     0,     3,
   168,     0,    51,     0,    52,     0,    53,     0,    54,     0,
    55,     0,    56,     0,    57,     0,    58,     0,    59,     0,
    60,     0,    61,     0,    79,     0,    80,     0,    16,     0,
    17,     0,    81,    16,     0,    82,    16,     0,    81,    17,
     0,    82,    17,     0,    97,     0,    98,     0,    81,    97,
     0,    82,    97,     0,    81,    98,     0,    82,    98,     0,
    99,     0,   101,     0,   100,     0,     4,     0,     5,     0,
   162,    62,     0,   162,    63,     0,   162,    64,     0,   162,
    65,     0,   162,    66,     0,   171,   115,   171,     0,   171,
   116,   171,     0,   171,   117,   171,     0,   171,   118,   171,
     0,   171,   119,   171,     0,   171,   121,   171,     0,   116,
   171,     0,   111,   171,   129,     0,    67,   111,   171,   129,
     0,    68,   111,   171,   129,     0,    69,   111,   171,   112,
   171,   129,     0,    70,   111,   171,   129,     0,    71,   111,
   171,   129,     0,    72,   111,   171,   129,     0,    73,   111,
   171,   112,   171,   129,     0,    74,   111,   171,   112,   171,
   129,     0,    75,   111,   171,   129,     0,    76,   111,   171,
   129,     0,    76,   111,   129,     0,   171,   113,   171,     0,
   171,    95,   171,     0,   171,   114,   171,     0,   171,    96,
   171,     0,   171,    94,   171,     0,   171,    93,   171,     0,
   171,    91,   171,     0,   171,    92,   171,     0,   120,   171,
     0
};

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   265,   267,   275,   280,   283,   287,   289,   292,   294,   297,
   303,   305,   307,   309,   311,   317,   322,   328,   333,   336,
   341,   348,   351,   353,   361,   364,   366,   373,   376,   382,
   390,   393,   404,   405,   409,   412,   414,   418,   422,   425,
   428,   432,   435,   441,   448,   451,   453,   457,   472,   474,
   482,   488,   494,   501,   504,   512,   515,   519,   524,   528,
   532,   537,   544,   551,   558,   565,   570,   575,   582,   597,
   609,   615,   621,   627,   633,   652,   659,   666,   673,   680,
   687,   694,   701,   708,   715,   730,   742,   748,   755,   767,
   773,   779,   785,   791,   796,   802,   818,   835,   840,   845,
   850,   855,   860,   865,   870,   877,   886,   895,   904,   913,
   919,   926,   931,   941,   948,   969,   972,   980,   983,   988,
   993,   998,  1003,  1010,  1012,  1015,  1018,  1022,  1025,  1031,
  1037,  1043,  1051,  1062,  1066,  1074,  1077,  1081,  1096,  1112,
  1115,  1117,  1119,  1121,  1123,  1125,  1127,  1129,  1133,  1138,
  1145,  1153,  1157,  1164,  1170,  1176,  1182,  1188,  1196,  1199,
  1201,  1203,  1205,  1207,  1209,  1211,  1213,  1215,  1217,  1219,
  1221,  1223,  1225,  1227,  1229,  1231,  1233,  1235,  1237,  1239,
  1241,  1243,  1245,  1247,  1249,  1251,  1255,  1264,  1266,  1273,
  1280,  1287,  1294,  1301,  1303,  1305,  1307,  1315,  1323,  1336,
  1338,  1340,  1349,  1358,  1371,  1380,  1389,  1398,  1400,  1402,
  1404,  1406,  1412,  1414,  1416,  1418,  1420,  1422,  1424,  1426,
  1428
};

static const char * const yytname[] = {   "$",
"error","$illegal.","LABEL","VARIABLE","NUMBER","TEXT","COMMAND","DELIMITED","ORDINAL","LEFT_ARROW_HEAD",
"RIGHT_ARROW_HEAD","DOUBLE_ARROW_HEAD","LAST","UP","DOWN","LEFT","RIGHT","BOX","CIRCLE","ELLIPSE",
"ARC","LINE","ARROW","MOVE","SPLINE","HEIGHT","RADIUS","WIDTH","DIAMETER","FROM",
"TO","AT","WITH","BY","THEN","DOTTED","DASHED","CHOP","SAME","INVISIBLE",
"LJUST","RJUST","ABOVE","BELOW","OF","THE","WAY","BETWEEN","AND","HERE",
"DOT_N","DOT_E","DOT_W","DOT_S","DOT_NE","DOT_SE","DOT_NW","DOT_SW","DOT_C","DOT_START",
"DOT_END","DOT_X","DOT_Y","DOT_HT","DOT_WID","DOT_RAD","SIN","COS","ATAN2","LOG",
"EXP","SQRT","MAX","MIN","INT","RAND","COPY","THRU","TOP","BOTTOM",
"UPPER","LOWER","SH","PRINT","CW","CCW","FOR","DO","IF","ELSE",
"ANDAND","OROR","NOTEQUAL","EQUALEQUAL","LESSEQUAL","GREATEREQUAL","LEFT_CORNER","RIGHT_CORNER","CENTER","END",
"START","RESET","UNTIL","PLOT","THICKNESS","FILL","ALIGNED","SPRINTF","DEFINE","UNDEF",
"'('","','","'<'","'>'","'+'","'-'","'*'","'/'","'%'","'!'",
"'^'","';'","'='","':'","'{'","'}'","'['","']'","')'","'.'",
"top","element_list","middle_element_list","optional_separator","separator","placeless_element","@1","@2","@3","@4",
"@5","@6","@7","reset_variables","simple_if","@8","until","conditional_expr","optional_by","element",
"@9","@10","optional_element","object_spec","@11","text","sprintf_args","position","position_not_place","between",
"expr_pair","place","label","optional_ordinal_last","nth_primitive","object_type","label_path","relative_path","path","corner",
"expr",""
};
#endif

static const short yyr1[] = {     0,
   131,   131,   132,   133,   133,   134,   134,   135,   135,   136,
   136,   136,   136,   136,   136,   136,   136,   136,   137,   136,
   136,   138,   139,   136,   140,   141,   136,   142,   136,   136,
   143,   136,   136,   136,   144,   144,   144,   146,   145,   147,
   147,   148,   148,   148,   149,   149,   149,   150,   150,   150,
   150,   151,   152,   150,   150,   153,   153,   154,   154,   154,
   154,   154,   154,   154,   154,   154,   154,   154,   155,   154,
   154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
   154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
   154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
   154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
   154,   156,   156,   157,   157,   158,   158,   159,   159,   159,
   159,   159,   159,   160,   160,   161,   161,   162,   162,   162,
   162,   162,   163,   163,   163,   164,   164,   165,   165,   166,
   166,   166,   166,   166,   166,   166,   166,   166,   167,   167,
   168,   168,   168,   169,   169,   169,   169,   169,   170,   170,
   170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
   170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
   170,   170,   170,   170,   170,   170,   171,   171,   171,   171,
   171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
   171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
   171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
   171
};

static const short yyr2[] = {     0,
     1,     1,     3,     1,     3,     0,     1,     1,     2,     3,
     1,     1,     1,     1,     1,     2,     2,     2,     0,     3,
     2,     0,     0,     7,     0,     0,     6,     0,    10,     1,
     0,     4,     1,     1,     2,     2,     3,     0,     5,     0,
     2,     1,     3,     3,     0,     2,     3,     1,     4,     4,
     4,     0,     0,     6,     1,     0,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     2,     3,     0,     4,
     3,     3,     3,     3,     2,     2,     3,     2,     3,     2,
     3,     2,     3,     3,     3,     3,     3,     3,     2,     2,
     3,     2,     3,     2,     3,     2,     3,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
     2,     1,     5,     0,     3,     1,     1,     1,     3,     3,
     5,     5,     6,     1,     4,     3,     3,     1,     2,     2,
     3,     1,     1,     1,     3,     1,     2,     2,     2,     1,
     1,     1,     1,     1,     1,     1,     2,     1,     2,     3,
     1,     1,     2,     1,     4,     3,     3,     2,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     2,     2,     2,     2,     1,     1,     2,
     2,     2,     2,     1,     1,     1,     1,     1,     2,     2,
     2,     2,     2,     3,     3,     3,     3,     3,     3,     2,
     3,     4,     4,     6,     4,     4,     4,     6,     6,     4,
     4,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     2
};

static const short yydefact[] = {     6,
     8,     2,     1,     7,     0,     0,   112,    15,    11,    12,
    13,    14,    58,    59,    60,    61,    62,    63,    64,    65,
     0,    19,     0,     0,     0,    34,     0,     0,    52,    69,
     6,    55,    33,    30,     4,    48,    66,     9,     6,     0,
    21,    25,     0,   133,   187,   188,     0,   136,   172,   173,
   132,   159,   160,   161,   162,   163,   164,   165,   166,   167,
   168,   169,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   170,   171,     0,     0,   178,   179,   184,   186,
   185,     0,     0,     0,    17,    18,   116,   118,   117,   128,
     0,   134,     0,    16,     0,     0,     0,     0,     0,    42,
    35,    67,     0,     6,     6,     3,     7,    36,     0,    31,
   100,   101,   102,    76,    78,    82,    80,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    89,    90,    92,    96,
    98,    99,   106,   107,   108,   109,   103,   104,     0,    94,
   111,   105,    75,     0,    10,    22,     0,    20,   148,   137,
   140,   141,   142,   143,   144,   145,   146,     0,   138,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
   176,   180,   182,   175,   177,   181,   183,     0,   118,     0,
   200,   221,     0,     0,   189,   190,   191,   192,   193,     0,
   129,   139,     0,   130,     0,   124,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    38,     0,     0,     0,    68,   114,
     0,     0,     0,     5,    37,     0,    77,    79,    83,    81,
    71,    72,    73,    74,    84,     0,    85,    86,     0,     0,
     0,     0,   152,   154,    87,   151,     0,    88,     0,    91,
    93,    97,   110,    95,   133,   187,    13,    14,    49,     0,
    50,    51,     0,    26,   147,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   212,     0,     0,   127,   201,   119,
   120,   135,   131,     0,   219,   220,   218,   217,   214,   216,
   126,     0,   213,   215,   194,   195,   196,   197,   198,   199,
     0,     0,     0,    44,    43,   213,     0,    53,    70,    32,
   158,     0,     0,     0,   149,     0,   153,     0,     0,    23,
    40,   202,   203,     0,   205,   206,   207,     0,     0,   210,
   211,     0,     0,     0,     0,     0,    39,     0,   113,    56,
     0,   157,   156,   150,    40,     0,    27,     0,     0,     0,
   121,   125,     0,   122,    45,   115,    57,    54,   155,    24,
    41,   204,   208,   209,   123,     0,     0,     0,    46,    28,
    47,     0,    29,     0,     0,     0
};

static const short yydefgoto[] = {   374,
     2,    31,   222,     4,    32,    43,   263,   345,   147,   321,
   372,   226,    33,    34,   303,   347,    97,   367,    35,   104,
   340,   358,    36,   105,    37,   307,    86,    87,   212,    88,
    99,    90,    91,    92,   159,   243,   244,   245,    93,   236
};

static const short yypact[] = {  -107,
-32768,-32768,   574,  -104,  -103,   -97,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    10,-32768,   789,    26,   890,    33,  1096,   -65,-32768,-32768,
  -107,-32768,     1,   -56,-32768,   680,-32768,-32768,  -107,   890,
   -20,-32768,    47,-32768,-32768,-32768,    29,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   -48,   -39,   -37,   -35,   -32,    -7,     8,    24,
    51,    54,-32768,-32768,    23,    50,-32768,-32768,-32768,-32768,
-32768,  1197,  1096,  1096,-32768,   -26,-32768,-32768,    87,  1671,
   198,-32768,    19,   491,     7,  1096,    99,    30,    87,  1993,
-32768,  1023,   187,  -107,  -107,-32768,   548,-32768,   190,-32768,
-32768,-32768,-32768,  1538,  1538,  1378,  1458,  1096,  1096,  1096,
  1096,  1197,  1197,  1197,   193,  1298,-32768,  1538,  1538,  1538,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1096,  1538,
-32768,-32768,  1993,   433,-32768,-32768,   189,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    75,-32768,  1096,
  1096,  1096,  1096,  1096,  1096,  1096,  1096,  1096,   315,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -59,    76,   167,
    86,    86,  1298,  1298,-32768,-32768,-32768,-32768,-32768,   205,
-32768,-32768,    20,    81,   168,-32768,  1096,  1096,  1096,  1096,
  1096,  1096,  1096,  1197,  1096,  1096,  1096,  1096,  1096,  1096,
  1096,  1197,  1096,  1721,-32768,     6,     6,  1096,-32768,-32768,
    96,   574,    85,-32768,-32768,   220,  1993,  1993,  1993,  1993,
  1993,  1993,  1993,  1993,   -26,   491,   -26,   -26,  1608,    62,
   198,   228,  1660,-32768,-32768,-32768,  1298,-32768,   716,  1993,
  1993,  1993,  1993,  1993,  -103,   -97,   109,   123,-32768,   -26,
    42,   284,   224,-32768,-32768,  1730,  1761,  1579,  1770,  1801,
  1810,  1952,  1962,  1841,-32768,  1850,  1197,-32768,-32768,-32768,
-32768,-32768,    81,   186,   759,   817,   306,   306,   150,   150,
  1993,    55,   121,   150,   181,   181,    86,    86,    86,    86,
   -38,   525,   233,-32768,-32768,   150,   -93,-32768,-32768,-32768,
-32768,   198,  1608,  1608,-32768,   240,-32768,    76,  1690,-32768,
   174,-32768,-32768,  1096,-32768,-32768,-32768,  1096,  1096,-32768,
-32768,   -14,   222,  1197,  1197,  1096,-32768,  1096,-32768,   574,
  1608,-32768,-32768,-32768,   174,   272,-32768,  1881,  1890,  1921,
-32768,-32768,   111,   -26,   242,  1993,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   991,   199,  1096,  1993,-32768,
  1993,   281,-32768,   295,   297,-32768
};

static const short yypgoto[] = {-32768,
    68,-32768,    31,   273,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -42,   267,-32768,  -106,-32768,
-32768,-32768,-32768,-32768,   -16,-32768,   -79,   164,-32768,   -55,
   -13,   -85,-32768,-32768,   -77,-32768,  -214,-32768,   -84,   -23
};


#define	YYLAST		2114


static const short yytable[] = {    94,
   224,   100,   178,   102,   108,   191,    85,   194,    98,    89,
   335,     7,   143,   192,     1,    41,   100,    38,   338,   142,
    39,    44,    44,    98,   311,    40,   179,    47,    47,    95,
     3,    48,    48,   110,   149,   339,   101,   259,   170,   171,
   246,   150,   235,   237,   238,   103,   151,   152,   153,   154,
   155,   156,   277,   157,   148,   183,   184,   146,   180,   181,
   182,   106,   160,   193,   260,   174,   175,   149,    89,   144,
   248,   161,   214,   162,   312,   163,   183,   184,   164,   151,
   152,   153,   154,   155,   156,   219,   157,    42,   183,   184,
   227,   228,   229,   230,   231,   232,   233,   234,   342,   343,
   183,   184,   249,   165,   250,   251,   252,   283,    89,    89,
    89,  -172,   109,    28,   351,   253,   254,  -172,   166,   172,
   173,  -172,   216,   217,   292,  -173,   359,   280,   281,   213,
   262,  -173,   301,   215,   167,  -173,   266,   267,   268,   269,
   270,   271,   272,   273,   274,   276,   176,   177,   185,   186,
   187,   188,   189,  -172,   246,   158,  -116,  -116,   317,   249,
   249,   168,   313,   314,   169,   195,   334,  -173,   196,   183,
   184,   221,   223,   285,   286,   287,   288,   289,   290,   291,
   293,   294,   295,   296,   297,   298,   299,   300,   158,   302,
    89,   318,   220,   225,   306,   239,   264,   332,    89,   304,
   305,   240,   265,   149,   278,   241,   211,   282,    49,    50,
   190,   195,   309,   284,   196,   151,   152,   153,   154,   155,
   156,   308,   157,   319,   365,   183,   184,   310,   246,   246,
   315,   320,   333,   357,   341,   206,   207,   208,   209,   210,
   337,   211,   344,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    62,   353,   354,   246,   197,   198,   199,
   200,   201,   202,    89,   206,   207,   208,   209,   210,   352,
   211,    73,    74,    75,    76,   366,   346,   361,   203,   204,
   205,   206,   207,   208,   209,   210,   370,   211,   373,    77,
    78,    79,    80,    81,   375,   279,   376,   208,   209,   210,
   348,   211,   360,   107,   349,   350,   145,   261,     0,     0,
     0,     0,   355,     0,   356,     0,     0,    44,    45,    46,
    89,    89,   242,    47,   158,     0,     0,    48,     0,     0,
    49,    50,   197,   198,   199,   200,   201,   202,     0,     0,
     0,     0,   369,     0,   371,   185,   186,   187,   188,   189,
     0,     0,     0,     0,   218,   205,   206,   207,   208,   209,
   210,     0,   211,     0,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,     0,     0,     0,     0,
     0,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,     0,     0,    73,    74,    75,    76,     0,  -117,  -117,
   201,   202,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    77,    78,    79,    80,    81,     0,     0,   218,   205,
   206,   207,   208,   209,   210,    96,   211,     0,     0,     0,
    83,     0,     0,     0,    84,   255,   256,    46,     7,     8,
     0,    47,     0,   275,     0,    48,     9,    10,   257,   258,
    13,    14,    15,    16,    17,    18,    19,    20,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    62,     0,     0,     0,     0,     0,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    21,
     0,    73,    74,    75,    76,    22,    23,     0,     0,    24,
     0,    25,     0,     0,     0,     0,     0,     0,     0,    77,
    78,    79,    80,    81,    26,   195,    27,     0,   196,     0,
    28,     0,     0,    82,     0,     0,     0,     0,    83,     0,
     5,     6,    84,     7,     8,   336,     0,    29,     0,    30,
     0,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,     0,     0,     0,     5,     6,     0,     7,
     8,   197,   198,   199,   200,   201,   202,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,     0,
     0,     0,   203,   204,   205,   206,   207,   208,   209,   210,
     0,   211,     0,     0,     0,   197,   198,   199,   200,   201,
   202,     0,     0,     0,    21,     0,     0,     0,     0,     0,
    22,    23,     0,     0,    24,     0,    25,   218,   205,   206,
   207,   208,   209,   210,     0,   211,     0,     0,     0,    26,
    21,    27,     0,     0,     0,    28,    22,    23,     0,     0,
    24,     0,    25,     0,     0,     0,     0,     0,     0,    38,
     0,     0,    29,     0,    30,    26,     0,    27,     0,     0,
     0,    28,    44,    45,    46,     7,     0,     0,    47,   111,
   112,   113,    48,   114,   115,   116,   117,     0,    29,     0,
    30,     0,     0,     0,     0,   118,   119,   120,   121,   122,
   123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
   133,   134,   135,   136,     0,     0,     0,     0,     0,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,     0,     0,     0,     0,     0,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,     0,     0,    73,    74,
    75,    76,     0,     0,   137,   138,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    77,    78,    79,    80,
    81,     0,     0,     0,   139,   140,   141,    28,     0,     0,
    96,    44,    45,    46,     7,    83,     0,    47,     0,    84,
     0,    48,     0,     0,    49,    50,   197,   198,   199,   200,
   201,   202,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   203,   218,   205,
   206,   207,   208,   209,   210,     0,   211,     0,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
     0,   199,   200,   201,   202,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,     0,     0,    73,    74,    75,
    76,   218,   205,   206,   207,   208,   209,   210,     0,   211,
     0,     0,     0,     0,     0,    77,    78,    79,    80,    81,
     0,     0,    44,    45,    46,     7,    28,     0,    47,    82,
     0,     0,    48,     0,    83,    49,    50,   197,    84,   199,
   200,   201,   202,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   218,
   205,   206,   207,   208,   209,   210,     0,   211,     0,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,     0,     0,     0,     0,     0,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,     0,     0,    73,    74,
    75,    76,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    77,    78,    79,    80,
    81,     0,     0,    44,    45,    46,     0,    28,     0,    47,
    96,     0,     0,    48,     0,    83,    49,    50,     0,    84,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     7,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    62,     0,     0,     0,     0,     0,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,     0,     0,    73,
    74,    75,    76,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    77,    78,    79,
    80,    81,     0,     0,     0,     0,     0,     0,    44,    45,
    46,    96,     0,     0,    47,     0,    83,   368,    48,     0,
    84,    49,    50,   197,   198,   199,   200,   201,   202,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    28,     0,     0,     0,     0,   218,   205,   206,   207,   208,
   209,   210,     0,   211,     0,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,     0,     0,     0,
     0,     0,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,     0,     0,    73,    74,    75,    76,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    77,    78,    79,    80,    81,     0,     0,    44,
    45,    46,     0,     0,     0,    47,    96,     0,     0,    48,
     0,    83,    49,    50,     0,    84,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    62,     0,     0,
     0,     0,     0,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,     0,     0,    73,    74,    75,    76,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    77,    78,    79,    80,    81,     0,     0,
    44,    45,    46,     0,     0,     0,    47,    82,     0,     0,
    48,     0,    83,    49,    50,     0,    84,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,     0,
     0,     0,     0,     0,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,     0,     0,    73,    74,    75,    76,
    44,    45,    46,     0,     0,     0,    47,     0,     0,     0,
    48,     0,     0,     0,    77,    78,    79,    80,    81,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   247,     0,
     0,     0,     0,    83,     0,     0,     0,    84,     0,     0,
     0,     0,  -172,     0,     0,     0,     0,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,     0,
     0,     0,     0,     0,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,     0,     0,    73,    74,    75,    76,
    44,    45,    46,     0,     0,     0,    47,     0,     0,     0,
    48,     0,     0,     0,    77,    78,    79,    80,    81,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    96,     0,
     0,     0,     0,    83,     0,     0,     0,    84,     0,     0,
     0,     0,  -173,     0,     0,     0,     0,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,     0,
     0,     0,     0,     0,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,     0,     0,    73,    74,    75,    76,
    44,    45,    46,     0,     0,     0,    47,     0,     0,     0,
    48,     0,     0,     0,    77,    78,    79,    80,    81,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    96,     0,
     0,     0,     0,    83,     0,     0,     0,    84,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,     0,
     0,     0,     0,     0,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,     0,     0,    73,    74,    75,    76,
     0,     0,     0,    49,    50,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    77,    78,    79,    80,    81,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    96,     0,
     0,     0,     0,    83,     0,     0,     0,    84,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,   197,
   198,   199,   200,   201,   202,    49,    50,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    73,    74,    75,    76,
   324,   218,   205,   206,   207,   208,   209,   210,     0,   211,
     0,     0,     0,     0,    77,    78,    79,    80,    81,     0,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    62,     0,     0,     0,     0,     0,   242,    73,    74,
    75,    76,     0,     0,     0,     0,     0,     0,     0,    73,
    74,    75,    76,     0,     0,     0,    77,    78,    79,    80,
    81,     0,     0,     0,     0,     0,     0,    77,    78,    79,
    80,    81,     0,     0,     0,     0,     0,     0,     0,     0,
   197,   198,   199,   200,   201,   202,     0,     0,     0,   316,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   190,   203,   218,   205,   206,   207,   208,   209,   210,     0,
   211,   197,   198,   199,   200,   201,   202,     0,   279,     0,
   197,   198,   199,   200,   201,   202,     0,     0,     0,     0,
     0,     0,     0,   218,   205,   206,   207,   208,   209,   210,
     0,   211,   218,   205,   206,   207,   208,   209,   210,   279,
   211,   197,   198,   199,   200,   201,   202,     0,   322,     0,
   197,   198,   199,   200,   201,   202,     0,     0,     0,     0,
     0,     0,     0,   218,   205,   206,   207,   208,   209,   210,
     0,   211,   218,   205,   206,   207,   208,   209,   210,   323,
   211,   197,   198,   199,   200,   201,   202,     0,   325,     0,
   197,   198,   199,   200,   201,   202,     0,     0,     0,     0,
     0,     0,     0,   218,   205,   206,   207,   208,   209,   210,
     0,   211,   218,   205,   206,   207,   208,   209,   210,   326,
   211,   197,   198,   199,   200,   201,   202,     0,   327,     0,
   197,   198,   199,   200,   201,   202,     0,     0,     0,     0,
     0,     0,     0,   218,   205,   206,   207,   208,   209,   210,
     0,   211,   218,   205,   206,   207,   208,   209,   210,   330,
   211,   197,   198,   199,   200,   201,   202,     0,   331,     0,
   197,   198,   199,   200,   201,   202,     0,     0,     0,     0,
     0,     0,     0,   218,   205,   206,   207,   208,   209,   210,
     0,   211,   218,   205,   206,   207,   208,   209,   210,   362,
   211,   197,   198,   199,   200,   201,   202,     0,   363,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   218,   205,   206,   207,   208,   209,   210,
     0,   211,   197,   198,   199,   200,   201,   202,     0,   364,
     0,     0,   197,   198,   199,   200,   201,   202,     0,     0,
     0,     0,     0,   328,   218,   205,   206,   207,   208,   209,
   210,     0,   211,   329,   218,   205,   206,   207,   208,   209,
   210,     0,   211,   197,   198,   199,   200,   201,   202,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   218,   205,   206,   207,   208,
   209,   210,     0,   211
};

static const short yycheck[] = {    23,
   107,    25,    82,    27,     4,    90,    23,    93,    25,    23,
    49,     6,    36,    91,   122,     6,    40,   122,   112,    36,
   124,     3,     3,    40,   239,   123,    82,     9,     9,     4,
     0,    13,    13,    90,     6,   129,     4,   144,    16,    17,
   125,    13,   122,   123,   124,   111,    18,    19,    20,    21,
    22,    23,   112,    25,     8,   115,   116,    78,    82,    83,
    84,    31,   111,    45,   144,    16,    17,     6,    82,    39,
   126,   111,    96,   111,    13,   111,   115,   116,   111,    18,
    19,    20,    21,    22,    23,   102,    25,    78,   115,   116,
   114,   115,   116,   117,   118,   119,   120,   121,   313,   314,
   115,   116,   126,   111,   128,   129,   130,   193,   122,   123,
   124,     3,   112,   108,   129,   139,   140,     9,   111,    97,
    98,    13,    93,    94,   204,     3,   341,   183,   184,   123,
   144,     9,   212,    35,   111,    13,   160,   161,   162,   163,
   164,   165,   166,   167,   168,   169,    97,    98,    62,    63,
    64,    65,    66,    45,   239,   127,   115,   116,   243,   183,
   184,   111,   240,   241,   111,    45,   112,    45,    48,   115,
   116,   104,   105,   197,   198,   199,   200,   201,   202,   203,
   204,   205,   206,   207,   208,   209,   210,   211,   127,   213,
   204,   247,     6,     4,   218,     3,     8,   277,   212,   216,
   217,     9,   128,     6,   129,    13,   121,     3,    16,    17,
   130,    45,   128,    46,    48,    18,    19,    20,    21,    22,
    23,   126,    25,   247,   114,   115,   116,     8,   313,   314,
     3,     8,    47,   340,   312,   115,   116,   117,   118,   119,
     8,   121,     3,    51,    52,    53,    54,    55,    56,    57,
    58,    59,    60,    61,   334,   335,   341,    91,    92,    93,
    94,    95,    96,   277,   115,   116,   117,   118,   119,    48,
   121,    79,    80,    81,    82,    34,   103,     6,   112,   113,
   114,   115,   116,   117,   118,   119,    88,   121,     8,    97,
    98,    99,   100,   101,     0,   129,     0,   117,   118,   119,
   324,   121,   345,    31,   328,   329,    40,   144,    -1,    -1,
    -1,    -1,   336,    -1,   338,    -1,    -1,     3,     4,     5,
   334,   335,   130,     9,   127,    -1,    -1,    13,    -1,    -1,
    16,    17,    91,    92,    93,    94,    95,    96,    -1,    -1,
    -1,    -1,   366,    -1,   368,    62,    63,    64,    65,    66,
    -1,    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,
   119,    -1,   121,    -1,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,
    -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    -1,    -1,    79,    80,    81,    82,    -1,   115,   116,
    95,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    97,    98,    99,   100,   101,    -1,    -1,   113,   114,
   115,   116,   117,   118,   119,   111,   121,    -1,    -1,    -1,
   116,    -1,    -1,    -1,   120,     3,     4,     5,     6,     7,
    -1,     9,    -1,   129,    -1,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    50,    51,    52,    53,    54,    55,    56,    57,
    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    -1,    79,    80,    81,    82,    83,    84,    -1,    -1,    87,
    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
    98,    99,   100,   101,   102,    45,   104,    -1,    48,    -1,
   108,    -1,    -1,   111,    -1,    -1,    -1,    -1,   116,    -1,
     3,     4,   120,     6,     7,    31,    -1,   125,    -1,   127,
    -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    -1,    -1,    -1,     3,     4,    -1,     6,
     7,    91,    92,    93,    94,    95,    96,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
    -1,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
    -1,   121,    -1,    -1,    -1,    91,    92,    93,    94,    95,
    96,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
    83,    84,    -1,    -1,    87,    -1,    89,   113,   114,   115,
   116,   117,   118,   119,    -1,   121,    -1,    -1,    -1,   102,
    77,   104,    -1,    -1,    -1,   108,    83,    84,    -1,    -1,
    87,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,   122,
    -1,    -1,   125,    -1,   127,   102,    -1,   104,    -1,    -1,
    -1,   108,     3,     4,     5,     6,    -1,    -1,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    -1,   125,    -1,
   127,    -1,    -1,    -1,    -1,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    -1,    -1,    79,    80,
    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,    99,   100,
   101,    -1,    -1,    -1,   105,   106,   107,   108,    -1,    -1,
   111,     3,     4,     5,     6,   116,    -1,     9,    -1,   120,
    -1,    13,    -1,    -1,    16,    17,    91,    92,    93,    94,
    95,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,   113,   114,
   115,   116,   117,   118,   119,    -1,   121,    -1,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    -1,    93,    94,    95,    96,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    -1,    -1,    79,    80,    81,
    82,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
    -1,    -1,    -1,    -1,    -1,    97,    98,    99,   100,   101,
    -1,    -1,     3,     4,     5,     6,   108,    -1,     9,   111,
    -1,    -1,    13,    -1,   116,    16,    17,    91,   120,    93,
    94,    95,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
   114,   115,   116,   117,   118,   119,    -1,   121,    -1,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    -1,    -1,    79,    80,
    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,    99,   100,
   101,    -1,    -1,     3,     4,     5,    -1,   108,    -1,     9,
   111,    -1,    -1,    13,    -1,   116,    16,    17,    -1,   120,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    -1,    -1,    79,
    80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,    99,
   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
     5,   111,    -1,    -1,     9,    -1,   116,   117,    13,    -1,
   120,    16,    17,    91,    92,    93,    94,    95,    96,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   108,    -1,    -1,    -1,    -1,   113,   114,   115,   116,   117,
   118,   119,    -1,   121,    -1,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
    -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    -1,    -1,    79,    80,    81,    82,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    97,    98,    99,   100,   101,    -1,    -1,     3,
     4,     5,    -1,    -1,    -1,     9,   111,    -1,    -1,    13,
    -1,   116,    16,    17,    -1,   120,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    -1,    -1,
    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    -1,    -1,    79,    80,    81,    82,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    97,    98,    99,   100,   101,    -1,    -1,
     3,     4,     5,    -1,    -1,    -1,     9,   111,    -1,    -1,
    13,    -1,   116,    16,    17,    -1,   120,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
    -1,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    -1,    -1,    79,    80,    81,    82,
     3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,
    13,    -1,    -1,    -1,    97,    98,    99,   100,   101,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,
    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,    -1,    -1,
    -1,    -1,    45,    -1,    -1,    -1,    -1,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
    -1,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    -1,    -1,    79,    80,    81,    82,
     3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,
    13,    -1,    -1,    -1,    97,    98,    99,   100,   101,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,
    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,    -1,    -1,
    -1,    -1,    45,    -1,    -1,    -1,    -1,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
    -1,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    -1,    -1,    79,    80,    81,    82,
     3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,
    13,    -1,    -1,    -1,    97,    98,    99,   100,   101,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,
    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
    -1,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    -1,    -1,    79,    80,    81,    82,
    -1,    -1,    -1,    16,    17,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    97,    98,    99,   100,   101,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,
    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    91,
    92,    93,    94,    95,    96,    16,    17,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    82,
   112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
    -1,    -1,    -1,    -1,    97,    98,    99,   100,   101,    -1,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    51,    52,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    -1,    -1,    -1,    -1,    -1,   130,    79,    80,
    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
    80,    81,    82,    -1,    -1,    -1,    97,    98,    99,   100,
   101,    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,    99,
   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    91,    92,    93,    94,    95,    96,    -1,    -1,    -1,   130,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   130,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
   121,    91,    92,    93,    94,    95,    96,    -1,   129,    -1,
    91,    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
    -1,   121,   113,   114,   115,   116,   117,   118,   119,   129,
   121,    91,    92,    93,    94,    95,    96,    -1,   129,    -1,
    91,    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
    -1,   121,   113,   114,   115,   116,   117,   118,   119,   129,
   121,    91,    92,    93,    94,    95,    96,    -1,   129,    -1,
    91,    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
    -1,   121,   113,   114,   115,   116,   117,   118,   119,   129,
   121,    91,    92,    93,    94,    95,    96,    -1,   129,    -1,
    91,    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
    -1,   121,   113,   114,   115,   116,   117,   118,   119,   129,
   121,    91,    92,    93,    94,    95,    96,    -1,   129,    -1,
    91,    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
    -1,   121,   113,   114,   115,   116,   117,   118,   119,   129,
   121,    91,    92,    93,    94,    95,    96,    -1,   129,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
    -1,   121,    91,    92,    93,    94,    95,    96,    -1,   129,
    -1,    -1,    91,    92,    93,    94,    95,    96,    -1,    -1,
    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,    -1,   121,   112,   113,   114,   115,   116,   117,   118,
   119,    -1,   121,    91,    92,    93,    94,    95,    96,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   113,   114,   115,   116,   117,
   118,   119,    -1,   121
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#include <alloca.h>
#else /* Not sparc */
#ifdef MSDOS
#include <malloc.h>
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif

#line 160 "/usr/local/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/

#define YYPOPSTACK   (yyvsp--, yysp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yysp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
#ifdef YYLSP_NEEDED
		 &yyls1, size * sizeof (*yylsp),
#endif
		 &yystacksize);

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Next token is %d (%s)\n", yychar, yytname[yychar1]);
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symboles being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 268 "pic.y"
{
		  if (olist.head)
		    print_picture(olist.head);
		;
    break;}
case 3:
#line 277 "pic.y"
{ yyval.pl = yyvsp[-1].pl; ;
    break;}
case 4:
#line 282 "pic.y"
{ yyval.pl = yyvsp[0].pl; ;
    break;}
case 5:
#line 284 "pic.y"
{ yyval.pl = yyvsp[-2].pl; ;
    break;}
case 10:
#line 299 "pic.y"
{
		  define_variable(yyvsp[-2].str, yyvsp[0].x);
		  delete yyvsp[-2].str;
		;
    break;}
case 11:
#line 304 "pic.y"
{ current_direction = UP_DIRECTION; ;
    break;}
case 12:
#line 306 "pic.y"
{ current_direction = DOWN_DIRECTION; ;
    break;}
case 13:
#line 308 "pic.y"
{ current_direction = LEFT_DIRECTION; ;
    break;}
case 14:
#line 310 "pic.y"
{ current_direction = RIGHT_DIRECTION; ;
    break;}
case 15:
#line 312 "pic.y"
{
		  olist.append(make_command_object(yyvsp[0].lstr.str,
							 yyvsp[0].lstr.filename,
							 yyvsp[0].lstr.lineno));
		;
    break;}
case 16:
#line 318 "pic.y"
{
		  fprintf(stderr, "%g\n", yyvsp[0].x);
		  fflush(stderr);
		;
    break;}
case 17:
#line 323 "pic.y"
{
		  fprintf(stderr, "%s\n", yyvsp[0].lstr.str);
		  delete yyvsp[0].lstr.str;
		  fflush(stderr);
		;
    break;}
case 18:
#line 329 "pic.y"
{
		  fprintf(stderr, "%g, %g\n", yyvsp[0].pair.x, yyvsp[0].pair.y);
		  fflush(stderr);
		;
    break;}
case 19:
#line 334 "pic.y"
{ delim_flag = 1; ;
    break;}
case 20:
#line 336 "pic.y"
{
		  delim_flag = 0;
		  system(yyvsp[0].str);
		  delete yyvsp[0].str;
		;
    break;}
case 21:
#line 342 "pic.y"
{
		  if (yychar < 0)
		    do_lookahead();
		  do_copy(yyvsp[0].lstr.str);
		  // do not delete the filename
		;
    break;}
case 22:
#line 349 "pic.y"
{ delim_flag = 2; ;
    break;}
case 23:
#line 351 "pic.y"
{ delim_flag = 0; ;
    break;}
case 24:
#line 353 "pic.y"
{
		  if (yychar < 0)
		    do_lookahead();
		  copy_file_thru(yyvsp[-5].lstr.str, yyvsp[-2].str, yyvsp[0].str);
		  // do not delete the filename
		  delete yyvsp[-2].str;
		  delete yyvsp[0].str;
		;
    break;}
case 25:
#line 362 "pic.y"
{ delim_flag = 2; ;
    break;}
case 26:
#line 364 "pic.y"
{ delim_flag = 0; ;
    break;}
case 27:
#line 366 "pic.y"
{
		  if (yychar < 0)
		    do_lookahead();
		  copy_rest_thru(yyvsp[-2].str, yyvsp[0].str);
		  delete yyvsp[-2].str;
		  delete yyvsp[0].str;
		;
    break;}
case 28:
#line 374 "pic.y"
{ delim_flag = 1; ;
    break;}
case 29:
#line 376 "pic.y"
{
		  delim_flag = 0;
		  if (yychar < 0)
		    do_lookahead();
		  do_for(yyvsp[-8].str, yyvsp[-6].x, yyvsp[-4].x, yyvsp[-3].by.is_multiplicative, yyvsp[-3].by.val, yyvsp[0].str); 
		;
    break;}
case 30:
#line 383 "pic.y"
{
		  if (yychar < 0)
		    do_lookahead();
		  if (yyvsp[0].if_data.x != 0.0)
		    push_body(yyvsp[0].if_data.body);
		  delete yyvsp[0].if_data.body;
		;
    break;}
case 31:
#line 391 "pic.y"
{ delim_flag = 1; ;
    break;}
case 32:
#line 393 "pic.y"
{
		  delim_flag = 0;
		  if (yychar < 0)
		    do_lookahead();
		  if (yyvsp[-3].if_data.x != 0.0)
		    push_body(yyvsp[-3].if_data.body);
		  else
		    push_body(yyvsp[0].str);
		  delete yyvsp[-3].if_data.body;
		  delete yyvsp[0].str;
		;
    break;}
case 34:
#line 406 "pic.y"
{ define_variable("scale", 1.0); ;
    break;}
case 35:
#line 411 "pic.y"
{ reset(yyvsp[0].str); delete yyvsp[0].str; ;
    break;}
case 36:
#line 413 "pic.y"
{ reset(yyvsp[0].str); delete yyvsp[0].str; ;
    break;}
case 37:
#line 415 "pic.y"
{ reset(yyvsp[0].str); delete yyvsp[0].str; ;
    break;}
case 38:
#line 420 "pic.y"
{ delim_flag = 1; ;
    break;}
case 39:
#line 422 "pic.y"
{ delim_flag = 0; yyval.if_data.x = yyvsp[-3].x; yyval.if_data.body = yyvsp[0].str; ;
    break;}
case 40:
#line 427 "pic.y"
{ yyval.str = 0; ;
    break;}
case 41:
#line 429 "pic.y"
{ yyval.str = yyvsp[0].lstr.str; ;
    break;}
case 42:
#line 434 "pic.y"
{ yyval.x = yyvsp[0].x; ;
    break;}
case 43:
#line 436 "pic.y"
{
		  yyval.x = strcmp(yyvsp[-2].lstr.str, yyvsp[0].lstr.str) == 0;
		  delete yyvsp[-2].lstr.str;
		  delete yyvsp[0].lstr.str;
		;
    break;}
case 44:
#line 442 "pic.y"
{
		  yyval.x = strcmp(yyvsp[-2].lstr.str, yyvsp[0].lstr.str) != 0;
		  delete yyvsp[-2].lstr.str;
		  delete yyvsp[0].lstr.str;
		;
    break;}
case 45:
#line 450 "pic.y"
{ yyval.by.val = 1.0; yyval.by.is_multiplicative = 0; ;
    break;}
case 46:
#line 452 "pic.y"
{ yyval.by.val = yyvsp[0].x; yyval.by.is_multiplicative = 0; ;
    break;}
case 47:
#line 454 "pic.y"
{ yyval.by.val = yyvsp[0].x; yyval.by.is_multiplicative = 1; ;
    break;}
case 48:
#line 459 "pic.y"
{
		  yyval.pl.obj = yyvsp[0].spec->make_object(&current_position,
					   &current_direction);
		  if (yyval.pl.obj == 0)
		    YYABORT;
		  delete yyvsp[0].spec;
		  if (yyval.pl.obj)
		    olist.append(yyval.pl.obj);
		  else {
		    yyval.pl.x = current_position.x;
		    yyval.pl.y = current_position.y;
		  }
		;
    break;}
case 49:
#line 473 "pic.y"
{ yyval.pl = yyvsp[0].pl; define_label(yyvsp[-3].str, & yyval.pl); delete yyvsp[-3].str; ;
    break;}
case 50:
#line 475 "pic.y"
{
		  yyval.pl.obj = 0;
		  yyval.pl.x = yyvsp[0].pair.x;
		  yyval.pl.y = yyvsp[0].pair.y;
		  define_label(yyvsp[-3].str, & yyval.pl);
		  delete yyvsp[-3].str;
		;
    break;}
case 51:
#line 483 "pic.y"
{
		  yyval.pl = yyvsp[0].pl;
		  define_label(yyvsp[-3].str, & yyval.pl);
		  delete yyvsp[-3].str;
		;
    break;}
case 52:
#line 489 "pic.y"
{
		  yyval.state.x = current_position.x;
		  yyval.state.y = current_position.y;
		  yyval.state.dir = current_direction;
		;
    break;}
case 53:
#line 495 "pic.y"
{
		  current_position.x = yyvsp[-2].state.x;
		  current_position.y = yyvsp[-2].state.y;
		  current_direction = yyvsp[-2].state.dir;
		;
    break;}
case 54:
#line 501 "pic.y"
{
		  yyval.pl = yyvsp[-3].pl;
		;
    break;}
case 55:
#line 505 "pic.y"
{
		  yyval.pl.obj = 0;
		  yyval.pl.x = current_position.x;
		  yyval.pl.y = current_position.y;
		;
    break;}
case 56:
#line 514 "pic.y"
{;
    break;}
case 57:
#line 516 "pic.y"
{;
    break;}
case 58:
#line 521 "pic.y"
{
		  yyval.spec = new object_spec(BOX_OBJECT);
		;
    break;}
case 59:
#line 525 "pic.y"
{
		  yyval.spec = new object_spec(CIRCLE_OBJECT);
		;
    break;}
case 60:
#line 529 "pic.y"
{
		  yyval.spec = new object_spec(ELLIPSE_OBJECT);
		;
    break;}
case 61:
#line 533 "pic.y"
{
		  yyval.spec = new object_spec(ARC_OBJECT);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 62:
#line 538 "pic.y"
{
		  yyval.spec = new object_spec(LINE_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 63:
#line 545 "pic.y"
{
		  yyval.spec = new object_spec(ARROW_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 64:
#line 552 "pic.y"
{
		  yyval.spec = new object_spec(MOVE_OBJECT);
		  lookup_variable("moveht", & yyval.spec->segment_height);
		  lookup_variable("movewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 65:
#line 559 "pic.y"
{
		  yyval.spec = new object_spec(SPLINE_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 66:
#line 566 "pic.y"
{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(yyvsp[0].lstr.str, yyvsp[0].lstr.filename, yyvsp[0].lstr.lineno);
		;
    break;}
case 67:
#line 571 "pic.y"
{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(format_number(0, yyvsp[0].x), 0, -1);
		;
    break;}
case 68:
#line 576 "pic.y"
{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(format_number(yyvsp[0].lstr.str, yyvsp[-1].x),
					   yyvsp[0].lstr.filename, yyvsp[0].lstr.lineno);
		  delete yyvsp[0].lstr.str;
		;
    break;}
case 69:
#line 583 "pic.y"
{
		  saved_state *p = new saved_state;
		  yyval.pstate = p;
		  p->x = current_position.x;
		  p->y = current_position.y;
		  p->dir = current_direction;
		  p->tbl = current_table;
		  p->prev = current_saved_state;
		  current_position.x = 0.0;
		  current_position.y = 0.0;
		  current_table = new PTABLE(place);
		  current_saved_state = p;
		  olist.append(make_mark_object());
		;
    break;}
case 70:
#line 598 "pic.y"
{
		  current_position.x = yyvsp[-2].pstate->x;
		  current_position.y = yyvsp[-2].pstate->y;
		  current_direction = yyvsp[-2].pstate->dir;
		  yyval.spec = new object_spec(BLOCK_OBJECT);
		  olist.wrap_up_block(& yyval.spec->oblist);
		  yyval.spec->tbl = current_table;
		  current_table = yyvsp[-2].pstate->tbl;
		  current_saved_state = yyvsp[-2].pstate->prev;
		  delete yyvsp[-2].pstate;
		;
    break;}
case 71:
#line 610 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->height = yyvsp[0].x;
		  yyval.spec->flags |= HAS_HEIGHT;
		;
    break;}
case 72:
#line 616 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->radius = yyvsp[0].x;
		  yyval.spec->flags |= HAS_RADIUS;
		;
    break;}
case 73:
#line 622 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->width = yyvsp[0].x;
		  yyval.spec->flags |= HAS_WIDTH;
		;
    break;}
case 74:
#line 628 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->radius = yyvsp[0].x/2.0;
		  yyval.spec->flags |= HAS_RADIUS;
		;
    break;}
case 75:
#line 634 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= HAS_SEGMENT;
		  switch (yyval.spec->dir) {
		  case UP_DIRECTION:
		    yyval.spec->segment_pos.y += yyvsp[0].x;
		    break;
		  case DOWN_DIRECTION:
		    yyval.spec->segment_pos.y -= yyvsp[0].x;
		    break;
		  case RIGHT_DIRECTION:
		    yyval.spec->segment_pos.x += yyvsp[0].x;
		    break;
		  case LEFT_DIRECTION:
		    yyval.spec->segment_pos.x -= yyvsp[0].x;
		    break;
		  }
		;
    break;}
case 76:
#line 653 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->dir = UP_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y += yyval.spec->segment_height;
		;
    break;}
case 77:
#line 660 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->dir = UP_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y += yyvsp[0].x;
		;
    break;}
case 78:
#line 667 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->dir = DOWN_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y -= yyval.spec->segment_height;
		;
    break;}
case 79:
#line 674 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->dir = DOWN_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y -= yyvsp[0].x;
		;
    break;}
case 80:
#line 681 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->dir = RIGHT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yyval.spec->segment_width;
		;
    break;}
case 81:
#line 688 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->dir = RIGHT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yyvsp[0].x;
		;
    break;}
case 82:
#line 695 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->dir = LEFT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x -= yyval.spec->segment_width;
		;
    break;}
case 83:
#line 702 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->dir = LEFT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x -= yyvsp[0].x;
		;
    break;}
case 84:
#line 709 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_FROM;
		  yyval.spec->from.x = yyvsp[0].pair.x;
		  yyval.spec->from.y = yyvsp[0].pair.y;
		;
    break;}
case 85:
#line 716 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  if (yyval.spec->flags & HAS_SEGMENT)
		    yyval.spec->segment_list = new segment(yyval.spec->segment_pos,
						   yyval.spec->segment_is_absolute,
						   yyval.spec->segment_list);
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x = yyvsp[0].pair.x;
		  yyval.spec->segment_pos.y = yyvsp[0].pair.y;
		  yyval.spec->segment_is_absolute = 1;
		  yyval.spec->flags |= HAS_TO;
		  yyval.spec->to.x = yyvsp[0].pair.x;
		  yyval.spec->to.y = yyvsp[0].pair.y;
		;
    break;}
case 86:
#line 731 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_AT;
		  yyval.spec->at.x = yyvsp[0].pair.x;
		  yyval.spec->at.y = yyvsp[0].pair.y;
		  if (yyval.spec->type != ARC_OBJECT) {
		    yyval.spec->flags |= HAS_FROM;
		    yyval.spec->from.x = yyvsp[0].pair.x;
		    yyval.spec->from.y = yyvsp[0].pair.y;
		  }
		;
    break;}
case 87:
#line 743 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_WITH;
		  yyval.spec->with = yyvsp[0].pth;
		;
    break;}
case 88:
#line 749 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yyvsp[0].pair.x;
		  yyval.spec->segment_pos.y += yyvsp[0].pair.y;
		;
    break;}
case 89:
#line 756 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->flags & HAS_SEGMENT) {
		    yyval.spec->segment_list = new segment(yyval.spec->segment_pos,
						   yyval.spec->segment_is_absolute,
						   yyval.spec->segment_list);
		    yyval.spec->flags &= ~HAS_SEGMENT;
		    yyval.spec->segment_pos.x = yyval.spec->segment_pos.y = 0.0;
		    yyval.spec->segment_is_absolute = 0;
		  }
		;
    break;}
case 90:
#line 768 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_DOTTED;
		  lookup_variable("dashwid", & yyval.spec->dash_width);
		;
    break;}
case 91:
#line 774 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= IS_DOTTED;
		  yyval.spec->dash_width = yyvsp[0].x;
		;
    break;}
case 92:
#line 780 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_DASHED;
		  lookup_variable("dashwid", & yyval.spec->dash_width);
		;
    break;}
case 93:
#line 786 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= IS_DASHED;
		  yyval.spec->dash_width = yyvsp[0].x;
		;
    break;}
case 94:
#line 792 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_DEFAULT_FILLED;
		;
    break;}
case 95:
#line 797 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= IS_FILLED;
		  yyval.spec->fill = yyvsp[0].x;
		;
    break;}
case 96:
#line 803 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  // line chop chop means line chop 0 chop 0
		  if (yyval.spec->flags & IS_DEFAULT_CHOPPED) {
		    yyval.spec->flags |= IS_CHOPPED;
		    yyval.spec->flags &= ~IS_DEFAULT_CHOPPED;
		    yyval.spec->start_chop = yyval.spec->end_chop = 0.0;
		  }
		  else if (yyval.spec->flags & IS_CHOPPED) {
		    yyval.spec->end_chop = 0.0;
		  }
		  else {
		    yyval.spec->flags |= IS_DEFAULT_CHOPPED;
		  }
		;
    break;}
case 97:
#line 819 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  if (yyval.spec->flags & IS_DEFAULT_CHOPPED) {
		    yyval.spec->flags |= IS_CHOPPED;
		    yyval.spec->flags &= ~IS_DEFAULT_CHOPPED;
		    yyval.spec->start_chop = 0.0;
		    yyval.spec->end_chop = yyvsp[0].x;
		  }
		  else if (yyval.spec->flags & IS_CHOPPED) {
		    yyval.spec->end_chop = yyvsp[0].x;
		  }
		  else {
		    yyval.spec->start_chop = yyval.spec->end_chop = yyvsp[0].x;
		    yyval.spec->flags |= IS_CHOPPED;
		  }
		;
    break;}
case 98:
#line 836 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_SAME;
		;
    break;}
case 99:
#line 841 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_INVISIBLE;
		;
    break;}
case 100:
#line 846 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= HAS_LEFT_ARROW_HEAD;
		;
    break;}
case 101:
#line 851 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= HAS_RIGHT_ARROW_HEAD;
		;
    break;}
case 102:
#line 856 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= (HAS_LEFT_ARROW_HEAD|HAS_RIGHT_ARROW_HEAD);
		;
    break;}
case 103:
#line 861 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_CLOCKWISE;
		;
    break;}
case 104:
#line 866 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags &= ~IS_CLOCKWISE;
		;
    break;}
case 105:
#line 871 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  for (text_item **p = & yyval.spec->text; *p; p = &(*p)->next)
		    ;
		  *p = new text_item(yyvsp[0].lstr.str, yyvsp[0].lstr.filename, yyvsp[0].lstr.lineno);
		;
    break;}
case 106:
#line 878 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->text) {
		    for (text_item *p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.h = LEFT_ADJUST;
		  }
		;
    break;}
case 107:
#line 887 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->text) {
		    for (text_item *p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.h = RIGHT_ADJUST;
		  }
		;
    break;}
case 108:
#line 896 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->text) {
		    for (text_item *p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.v = ABOVE_ADJUST;
		  }
		;
    break;}
case 109:
#line 905 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->text) {
		    for (text_item *p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.v = BELOW_ADJUST;
		  }
		;
    break;}
case 110:
#line 914 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_THICKNESS;
		  yyval.spec->thickness = yyvsp[0].x;
		;
    break;}
case 111:
#line 920 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_ALIGNED;
		;
    break;}
case 112:
#line 928 "pic.y"
{
		  yyval.lstr = yyvsp[0].lstr;
		;
    break;}
case 113:
#line 932 "pic.y"
{
		  yyval.lstr.filename = yyvsp[-2].lstr.filename;
		  yyval.lstr.lineno = yyvsp[-2].lstr.lineno;
		  yyval.lstr.str = do_sprintf(yyvsp[-2].lstr.str, yyvsp[-1].dv.v, yyvsp[-1].dv.nv);
		  delete yyvsp[-1].dv.v;
		  delete yyvsp[-2].lstr.str;
		;
    break;}
case 114:
#line 943 "pic.y"
{
		  yyval.dv.v = 0;
		  yyval.dv.nv = 0;
		  yyval.dv.maxv = 0;
		;
    break;}
case 115:
#line 949 "pic.y"
{
		  yyval.dv = yyvsp[-2].dv;
		  if (yyval.dv.nv >= yyval.dv.maxv) {
		    if (yyval.dv.nv == 0) {
		      yyval.dv.v = new double[4];
		      yyval.dv.maxv = 4;
		    }
		    else {
		      double *oldv = yyval.dv.v;
		      yyval.dv.maxv *= 2;
		      yyval.dv.v = new double[yyval.dv.maxv];
		      memcpy(yyval.dv.v, oldv, yyval.dv.nv*sizeof(double));
		      delete oldv;
		    }
		  }
		  yyval.dv.v[yyval.dv.nv] = yyvsp[0].x;
		  yyval.dv.nv += 1;
		;
    break;}
case 116:
#line 971 "pic.y"
{ yyval.pair = yyvsp[0].pair; ;
    break;}
case 117:
#line 973 "pic.y"
{
		  position pos = yyvsp[0].pl;
		  yyval.pair.x = pos.x;
		  yyval.pair.y = pos.y;
		;
    break;}
case 118:
#line 982 "pic.y"
{ yyval.pair = yyvsp[0].pair; ;
    break;}
case 119:
#line 984 "pic.y"
{
		  yyval.pair.x = yyvsp[-2].pair.x + yyvsp[0].pair.x;
		  yyval.pair.y = yyvsp[-2].pair.y + yyvsp[0].pair.y;
		;
    break;}
case 120:
#line 989 "pic.y"
{
		  yyval.pair.x = yyvsp[-2].pair.x - yyvsp[0].pair.x;
		  yyval.pair.y = yyvsp[-2].pair.y - yyvsp[0].pair.y;
		;
    break;}
case 121:
#line 994 "pic.y"
{
		  yyval.pair.x = yyvsp[-3].pair.x;
		  yyval.pair.y = yyvsp[-1].pair.y;
		;
    break;}
case 122:
#line 999 "pic.y"
{
		  yyval.pair.x = (1.0 - yyvsp[-4].x)*yyvsp[-2].pair.x + yyvsp[-4].x*yyvsp[0].pair.x;
		  yyval.pair.y = (1.0 - yyvsp[-4].x)*yyvsp[-2].pair.y + yyvsp[-4].x*yyvsp[0].pair.y;
		;
    break;}
case 123:
#line 1004 "pic.y"
{
		  yyval.pair.x = (1.0 - yyvsp[-5].x)*yyvsp[-3].pair.x + yyvsp[-5].x*yyvsp[-1].pair.x;
		  yyval.pair.y = (1.0 - yyvsp[-5].x)*yyvsp[-3].pair.y + yyvsp[-5].x*yyvsp[-1].pair.y;
		;
    break;}
case 126:
#line 1017 "pic.y"
{ yyval.pair.x = yyvsp[-2].x; yyval.pair.y = yyvsp[0].x; ;
    break;}
case 127:
#line 1019 "pic.y"
{ yyval.pair = yyvsp[-1].pair; ;
    break;}
case 128:
#line 1024 "pic.y"
{ yyval.pl = yyvsp[0].pl; ;
    break;}
case 129:
#line 1026 "pic.y"
{
		  path pth(yyvsp[0].crn);
		  if (!pth.follow(yyvsp[-1].pl, & yyval.pl))
		    YYABORT;
		;
    break;}
case 130:
#line 1032 "pic.y"
{
		  path pth(yyvsp[-1].crn);
		  if (!pth.follow(yyvsp[0].pl, & yyval.pl))
		    YYABORT;
		;
    break;}
case 131:
#line 1038 "pic.y"
{
		  path pth(yyvsp[-2].crn);
		  if (!pth.follow(yyvsp[0].pl, & yyval.pl))
		    YYABORT;
		;
    break;}
case 132:
#line 1044 "pic.y"
{
		  yyval.pl.x = current_position.x;
		  yyval.pl.y = current_position.y;
		  yyval.pl.obj = 0;
		;
    break;}
case 133:
#line 1053 "pic.y"
{
		  place *p = lookup_label(yyvsp[0].str);
		  if (!p) {
		    lex_error("there is no place `%1'", yyvsp[0].str);
		    YYABORT;
		  }
		  yyval.pl = *p;
		  delete yyvsp[0].str;
		;
    break;}
case 134:
#line 1063 "pic.y"
{
		  yyval.pl.obj = yyvsp[0].obj;
		;
    break;}
case 135:
#line 1067 "pic.y"
{
		  path pth(yyvsp[0].str);
		  if (!pth.follow(yyvsp[-2].pl, & yyval.pl))
		    YYABORT;
		;
    break;}
case 136:
#line 1076 "pic.y"
{ yyval.n = 1; ;
    break;}
case 137:
#line 1078 "pic.y"
{ yyval.n = yyvsp[-1].n; ;
    break;}
case 138:
#line 1083 "pic.y"
{
		  int count = 0;
		  for (object *p = olist.head; p != 0; p = p->next)
		    if (p->type() == yyvsp[0].obtype && ++count == yyvsp[-1].n) {
		      yyval.obj = p;
		      break;
		    }
		  if (p == 0) {
		    lex_error("there is no %1%2 %3", yyvsp[-1].n, ordinal_postfix(yyvsp[-1].n),
			      object_type_name(yyvsp[0].obtype));
		    YYABORT;
		  }
		;
    break;}
case 139:
#line 1097 "pic.y"
{
		  int count = 0;
		  for (object *p = olist.tail; p != 0; p = p->prev)
		    if (p->type() == yyvsp[0].obtype && ++count == yyvsp[-1].n) {
		      yyval.obj = p;
		      break;
		    }
		  if (p == 0) {
		    lex_error("there is no %1%2 last %3", yyvsp[-1].n,
			      ordinal_postfix(yyvsp[-1].n), object_type_name(yyvsp[0].obtype));
		    YYABORT;
		  }
		;
    break;}
case 140:
#line 1114 "pic.y"
{ yyval.obtype = BOX_OBJECT; ;
    break;}
case 141:
#line 1116 "pic.y"
{ yyval.obtype = CIRCLE_OBJECT; ;
    break;}
case 142:
#line 1118 "pic.y"
{ yyval.obtype = ELLIPSE_OBJECT; ;
    break;}
case 143:
#line 1120 "pic.y"
{ yyval.obtype = ARC_OBJECT; ;
    break;}
case 144:
#line 1122 "pic.y"
{ yyval.obtype = LINE_OBJECT; ;
    break;}
case 145:
#line 1124 "pic.y"
{ yyval.obtype = ARROW_OBJECT; ;
    break;}
case 146:
#line 1126 "pic.y"
{ yyval.obtype = SPLINE_OBJECT; ;
    break;}
case 147:
#line 1128 "pic.y"
{ yyval.obtype = BLOCK_OBJECT; ;
    break;}
case 148:
#line 1130 "pic.y"
{ yyval.obtype = TEXT_OBJECT; ;
    break;}
case 149:
#line 1135 "pic.y"
{
		  yyval.pth = new path(yyvsp[0].str);
		;
    break;}
case 150:
#line 1139 "pic.y"
{
		  yyval.pth = yyvsp[-2].pth;
		  yyval.pth->append(yyvsp[0].str);
		;
    break;}
case 151:
#line 1147 "pic.y"
{
		  yyval.pth = new path(yyvsp[0].crn);
		;
    break;}
case 152:
#line 1154 "pic.y"
{
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 153:
#line 1158 "pic.y"
{
		  yyval.pth = yyvsp[-1].pth;
		  yyval.pth->append(yyvsp[0].crn);
		;
    break;}
case 154:
#line 1166 "pic.y"
{
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 155:
#line 1171 "pic.y"
{
		  lex_warning("`%1%2 last %3' in `with' argument ignored",
			      yyvsp[-3].n, ordinal_postfix(yyvsp[-3].n), object_type_name(yyvsp[-1].obtype));
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 156:
#line 1177 "pic.y"
{
		  lex_warning("`last %1' in `with' argument ignored",
			      object_type_name(yyvsp[-1].obtype));
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 157:
#line 1183 "pic.y"
{
		  lex_warning("`%1%2 %3' in `with' argument ignored",
			      yyvsp[-2].n, ordinal_postfix(yyvsp[-2].n), object_type_name(yyvsp[-1].obtype));
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 158:
#line 1189 "pic.y"
{
		  lex_warning("initial `%1' in `with' argument ignored", yyvsp[-1].str);
		  delete yyvsp[-1].str;
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 159:
#line 1198 "pic.y"
{ yyval.crn = &object::north; ;
    break;}
case 160:
#line 1200 "pic.y"
{ yyval.crn = &object::east; ;
    break;}
case 161:
#line 1202 "pic.y"
{ yyval.crn = &object::west; ;
    break;}
case 162:
#line 1204 "pic.y"
{ yyval.crn = &object::south; ;
    break;}
case 163:
#line 1206 "pic.y"
{ yyval.crn = &object::north_east; ;
    break;}
case 164:
#line 1208 "pic.y"
{ yyval.crn = &object:: south_east; ;
    break;}
case 165:
#line 1210 "pic.y"
{ yyval.crn = &object::north_west; ;
    break;}
case 166:
#line 1212 "pic.y"
{ yyval.crn = &object::south_west; ;
    break;}
case 167:
#line 1214 "pic.y"
{ yyval.crn = &object::center; ;
    break;}
case 168:
#line 1216 "pic.y"
{ yyval.crn = &object::start; ;
    break;}
case 169:
#line 1218 "pic.y"
{ yyval.crn = &object::end; ;
    break;}
case 170:
#line 1220 "pic.y"
{ yyval.crn = &object::north; ;
    break;}
case 171:
#line 1222 "pic.y"
{ yyval.crn = &object::south; ;
    break;}
case 172:
#line 1224 "pic.y"
{ yyval.crn = &object::west; ;
    break;}
case 173:
#line 1226 "pic.y"
{ yyval.crn = &object::east; ;
    break;}
case 174:
#line 1228 "pic.y"
{ yyval.crn = &object::north_west; ;
    break;}
case 175:
#line 1230 "pic.y"
{ yyval.crn = &object::south_west; ;
    break;}
case 176:
#line 1232 "pic.y"
{ yyval.crn = &object::north_east; ;
    break;}
case 177:
#line 1234 "pic.y"
{ yyval.crn = &object::south_east; ;
    break;}
case 178:
#line 1236 "pic.y"
{ yyval.crn = &object::west; ;
    break;}
case 179:
#line 1238 "pic.y"
{ yyval.crn = &object::east; ;
    break;}
case 180:
#line 1240 "pic.y"
{ yyval.crn = &object::north_west; ;
    break;}
case 181:
#line 1242 "pic.y"
{ yyval.crn = &object::south_west; ;
    break;}
case 182:
#line 1244 "pic.y"
{ yyval.crn = &object::north_east; ;
    break;}
case 183:
#line 1246 "pic.y"
{ yyval.crn = &object::south_east; ;
    break;}
case 184:
#line 1248 "pic.y"
{ yyval.crn = &object::center; ;
    break;}
case 185:
#line 1250 "pic.y"
{ yyval.crn = &object::start; ;
    break;}
case 186:
#line 1252 "pic.y"
{ yyval.crn = &object::end; ;
    break;}
case 187:
#line 1257 "pic.y"
{
		  if (!lookup_variable(yyvsp[0].str, & yyval.x)) {
		    lex_error("there is no variable `%1'", yyvsp[0].str);
		    YYABORT;
		  }
		  delete yyvsp[0].str;
		;
    break;}
case 188:
#line 1265 "pic.y"
{ yyval.x = yyvsp[0].x; ;
    break;}
case 189:
#line 1267 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->origin().x;
		  else
		    yyval.x = yyvsp[-1].pl.x;
		;
    break;}
case 190:
#line 1274 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->origin().y;
		  else
		    yyval.x = yyvsp[-1].pl.y;
		;
    break;}
case 191:
#line 1281 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->height();
		  else
		    yyval.x = 0.0;
		;
    break;}
case 192:
#line 1288 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->width();
		  else
		    yyval.x = 0.0;
		;
    break;}
case 193:
#line 1295 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->radius();
		  else
		    yyval.x = 0.0;
		;
    break;}
case 194:
#line 1302 "pic.y"
{ yyval.x = yyvsp[-2].x + yyvsp[0].x; ;
    break;}
case 195:
#line 1304 "pic.y"
{ yyval.x = yyvsp[-2].x - yyvsp[0].x; ;
    break;}
case 196:
#line 1306 "pic.y"
{ yyval.x = yyvsp[-2].x * yyvsp[0].x; ;
    break;}
case 197:
#line 1308 "pic.y"
{
		  if (yyvsp[0].x == 0.0) {
		    lex_error("division by zero");
		    YYABORT;
		  }
		  yyval.x = yyvsp[-2].x/yyvsp[0].x;
		;
    break;}
case 198:
#line 1316 "pic.y"
{
		  if (yyvsp[0].x == 0.0) {
		    lex_error("modulus by zero");
		    YYABORT;
		  }
		  yyval.x = fmod(yyvsp[-2].x, yyvsp[0].x);
		;
    break;}
case 199:
#line 1324 "pic.y"
{
		  errno = 0;
		  yyval.x = pow(yyvsp[-2].x, yyvsp[0].x);
		  if (errno == EDOM) {
		    lex_error("arguments to `^' operator out of domain");
		    YYABORT;
		  }
		  if (errno == ERANGE) {
		    lex_error("result of `^' operator out of range");
		    YYABORT;
		  }
		;
    break;}
case 200:
#line 1337 "pic.y"
{ yyval.x = -yyvsp[0].x; ;
    break;}
case 201:
#line 1339 "pic.y"
{ yyval.x = yyvsp[-1].x; ;
    break;}
case 202:
#line 1341 "pic.y"
{
		  errno = 0;
		  yyval.x = sin(yyvsp[-1].x);
		  if (errno == ERANGE) {
		    lex_error("sin result out of range");
		    YYABORT;
		  }
		;
    break;}
case 203:
#line 1350 "pic.y"
{
		  errno = 0;
		  yyval.x = cos(yyvsp[-1].x);
		  if (errno == ERANGE) {
		    lex_error("cos result out of range");
		    YYABORT;
		  }
		;
    break;}
case 204:
#line 1359 "pic.y"
{
		  errno = 0;
		  yyval.x = atan2(yyvsp[-3].x, yyvsp[-1].x);
		  if (errno == EDOM) {
		    lex_error("atan2 argument out of domain");
		    YYABORT;
		  }
		  if (errno == ERANGE) {
		    lex_error("atan2 result out of range");
		    YYABORT;
		  }
		;
    break;}
case 205:
#line 1372 "pic.y"
{
		  errno = 0;
		  yyval.x = log10(yyvsp[-1].x);
		  if (errno == ERANGE) {
		    lex_error("log result out of range");
		    YYABORT;
		  }
		;
    break;}
case 206:
#line 1381 "pic.y"
{
		  errno = 0;
		  yyval.x = pow(10.0, yyvsp[-1].x);
		  if (errno == ERANGE) {
		    lex_error("exp result out of range");
		    YYABORT;
		  }
		;
    break;}
case 207:
#line 1390 "pic.y"
{
		  errno = 0;
		  yyval.x = sqrt(yyvsp[-1].x);
		  if (errno == EDOM) {
		    lex_error("sqrt argument out of domain");
		    YYABORT;
		  }
		;
    break;}
case 208:
#line 1399 "pic.y"
{ yyval.x = yyvsp[-3].x > yyvsp[-1].x ? yyvsp[-3].x : yyvsp[-1].x; ;
    break;}
case 209:
#line 1401 "pic.y"
{ yyval.x = yyvsp[-3].x > yyvsp[-1].x ? yyvsp[-3].x : yyvsp[-1].x; ;
    break;}
case 210:
#line 1403 "pic.y"
{ yyval.x = floor(yyvsp[-1].x); ;
    break;}
case 211:
#line 1405 "pic.y"
{ yyval.x = 1.0 + floor(((rand()&0x7fff)/double(0x7fff))*yyvsp[-1].x); ;
    break;}
case 212:
#line 1407 "pic.y"
{
		  /* return a random number in the range [0,1) */
		  /* portable, but not very random */
		  yyval.x = (rand() & 0x7fff) / double(0x8000);
		;
    break;}
case 213:
#line 1413 "pic.y"
{ yyval.x = (yyvsp[-2].x < yyvsp[0].x); ;
    break;}
case 214:
#line 1415 "pic.y"
{ yyval.x = (yyvsp[-2].x <= yyvsp[0].x); ;
    break;}
case 215:
#line 1417 "pic.y"
{ yyval.x = (yyvsp[-2].x > yyvsp[0].x); ;
    break;}
case 216:
#line 1419 "pic.y"
{ yyval.x = (yyvsp[-2].x >= yyvsp[0].x); ;
    break;}
case 217:
#line 1421 "pic.y"
{ yyval.x = (yyvsp[-2].x == yyvsp[0].x); ;
    break;}
case 218:
#line 1423 "pic.y"
{ yyval.x = (yyvsp[-2].x != yyvsp[0].x); ;
    break;}
case 219:
#line 1425 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 && yyvsp[0].x != 0.0); ;
    break;}
case 220:
#line 1427 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 || yyvsp[0].x != 0.0); ;
    break;}
case 221:
#line 1429 "pic.y"
{ yyval.x = (yyvsp[0].x == 0.0); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 423 "/usr/local/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) xmalloc(size + 15);
	  strcpy(msg, "parse error");

	  if (count < 5)
	    {
	      count = 0;
	      for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
		if (yycheck[x + yyn] == x)
		  {
		    strcat(msg, count == 0 ? ", expecting `" : " or `");
		    strcat(msg, yytname[x]);
		    strcat(msg, "'");
		    count++;
		  }
	    }
	  yyerror(msg);
	  free(msg);
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1433 "pic.y"


/* bison defines const to be empty unless __STDC__ is defined, which it
isn't under cfront */

#ifdef const
#undef const
#endif

static struct {
  const char *name;
  double val;
  int scaled;		     // non-zero if val should be multiplied by scale
} defaults_table[] = {
  "arcrad", .25, 1,
  "arrowht", .1, 1,
  "arrowwid", .05, 1,
  "circlerad", .25, 1,
  "boxht", .5, 1,
  "boxwid", .75, 1,
  "boxrad", 0.0, 1,
  "dashwid", .05, 1,
  "ellipseht", .5, 1,
  "ellipsewid", .75, 1,
  "moveht", .5, 1,
  "movewid", .5, 1,
  "lineht", .5, 1,
  "linewid", .5, 1,
  "textht", 0.0, 1,
  "textwid", 0.0, 1,
  "scale", 1.0, 0,
  "linethick", -1.0, 0,		// in points
  "fillval", .5, 0,
  "arrowhead", 1.0, 0,
  "maxpswid", 8.5, 0,
  "maxpsht", 11.0, 0,
};

place *lookup_label(const char *label)
{
  saved_state *state = current_saved_state;
  PTABLE(place) *tbl = current_table;
  for (;;) {
    place *pl = tbl->lookup(label);
    if (pl)
      return pl;
    if (!state)
      return 0;
    tbl = state->tbl;
    state = state->prev;
  }
}

void define_label(const char *label, const place *pl)
{
  place *p = new place;
  *p = *pl;
  current_table->define(label, p);
}

int lookup_variable(const char *name, double *val)
{
  place *pl = lookup_label(name);
  if (pl) {
    *val = pl->x;
    return 1;
  }
  return 0;
}

void define_variable(const char *name, double val)
{
  place *p = new place;
  p->obj = 0;
  p->x = val;
  p->y = 0.0;
  current_table->define(name, p);
  if (strcmp(name, "scale") == 0) {
    // When the scale changes, reset all scaled pre-defined variables to
    // their default values.
    for (int i = 0; i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++) 
      if (defaults_table[i].scaled)
	define_variable(defaults_table[i].name, val*defaults_table[i].val);
  }
}

// called once only (not once per parse)

void parse_init()
{
  current_direction = RIGHT_DIRECTION;
  current_position.x = 0.0;
  current_position.y = 0.0;
  // This resets everything to its default value.
  reset_all();
}

void reset(const char *nm)
{
  for (int i = 0; i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++)
    if (strcmp(nm, defaults_table[i].name) == 0) {
      double val = defaults_table[i].val;
      if (defaults_table[i].scaled) {
	double scale;
	lookup_variable("scale", &scale);
	val *= scale;
      }
      define_variable(defaults_table[i].name, val);
      return;
    }
  lex_error("`%1' is not a predefined variable", nm);
}

void reset_all()
{
  // We only have to explicitly reset the pre-defined variables that
  // aren't scaled because `scale' is not scaled, and changing the
  // value of `scale' will reset all the pre-defined variables that
  // are scaled.
  for (int i = 0; i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++)
    if (!defaults_table[i].scaled)
      define_variable(defaults_table[i].name, defaults_table[i].val);
}

// called after each parse

void parse_cleanup()
{
  while (current_saved_state != 0) {
    delete current_table;
    current_table = current_saved_state->tbl;
    saved_state *tem = current_saved_state;
    current_saved_state = current_saved_state->prev;
    delete tem;
  }
  assert(current_table == &top_table);
  PTABLE_ITERATOR(place) iter(current_table);
  const char *key;
  place *pl;
  while (iter.next(&key, &pl))
    if (pl->obj != 0) {
      position pos = pl->obj->origin();
      pl->obj = 0;
      pl->x = pos.x;
      pl->y = pos.y;
    }
  while (olist.head != 0) {
    object *tem = olist.head;
    olist.head = olist.head->next;
    delete tem;
  }
  olist.tail = 0;
  current_direction = RIGHT_DIRECTION;
  current_position.x = 0.0;
  current_position.y = 0.0;
}

const char *ordinal_postfix(int n)
{
  if (n < 10 || n > 20)
    switch (n % 10) {
    case 1:
      return "st";
    case 2:
      return "nd";
    case 3:
      return "rd";
    }
  return "th";
}

const char *object_type_name(object_type type)
{
  switch (type) {
  case BOX_OBJECT:
    return "box";
  case CIRCLE_OBJECT:
    return "circle";
  case ELLIPSE_OBJECT:
    return "ellipse";
  case ARC_OBJECT:
    return "arc";
  case SPLINE_OBJECT:
    return "spline";
  case LINE_OBJECT:
    return "line";
  case ARROW_OBJECT:
    return "arrow";
  case MOVE_OBJECT:
    return "move";
  case TEXT_OBJECT:
    return "\"\"";
  case BLOCK_OBJECT:
    return "[]";
  case OTHER_OBJECT:
  case MARK_OBJECT:
  default:
    break;
  }
  return "object";
}

static char sprintf_buf[1024];

char *format_number(const char *form, double n)
{
  if (form == 0)
    form = "%g";
  else {
    // this is a fairly feeble attempt at validation of the format
    int nspecs = 0;
    for (const char *p = form; *p != '\0'; p++)
      if (*p == '%') {
	if (p[1] == '%')
	  p++;
	else
	  nspecs++;
      }
    if (nspecs > 1) {
      lex_error("bad format `%1'", form);
      return strsave(form);
    }
  }
  sprintf(sprintf_buf, form, n);
  return strsave(sprintf_buf);
}

char *do_sprintf(const char *form, const double *v, int nv)
{
  string result;
  int i = 0;
  string one_format;
  while (*form) {
    if (*form == '%') {
      one_format += *form++;
      for (; *form != '\0' && strchr("#-+ 0123456789.", *form) != 0; form++)
	one_format += *form;
      if (*form == '\0' || strchr("eEfgG%", *form) == 0) {
	lex_error("bad sprintf format");
	result += one_format;
	result += form;
	break;
      }
      if (*form == '%') {
	one_format += *form++;
	one_format += '\0';
	sprintf(sprintf_buf, one_format.contents());
      }
      else {
	if (i >= nv) {
	  lex_error("too few arguments to sprintf");
	  result += one_format;
	  result += form;
	  break;
	}
	one_format += *form++;
	one_format += '\0';
	sprintf(sprintf_buf, one_format.contents(), v[i++]);
      }
      one_format.clear();
      result += sprintf_buf;
    }
    else
      result += *form++;
  }
  result += '\0';
  return strsave(result.contents());
}
