#!/bin/sh
#
#	Expand the suffix flags in a list of ispell words.
#
#	Usage:
#
#	isexpand [ file ] ...
#
#	All suffixes in the given input files (standard input if none) are
#	expanded.  The output is sorted with sort -u to remove possible
#	duplications.
#
#		Geoff Kuenning
#		5/17/87
#
LIBDIR=!!LIBDIR!!
EXPAND1=${LIBDIR}/isexp1.sed
EXPAND2=${LIBDIR}/isexp2.sed
EXPAND3=${LIBDIR}/isexp3.sed
EXPAND4=${LIBDIR}/isexp4.sed

#
# We have to test $# because of a bug in the way /bin/sh expands "$@" when
# there are no arguments.
#
if [ $# -eq 0 ]
then
    sed -f $EXPAND1 | sed -f $EXPAND2 \
      | sed -f $EXPAND3 | sed -f $EXPAND4 | sort -u
else
    sed -f $EXPAND1 "$@" | sed -f $EXPAND2 \
      | sed -f $EXPAND3 | sed -f $EXPAND4 | sort -u
fi
