%{
char *sstk[20] = {0};
char *cstk[20] = {0};
char *pstk[20] = {0};
char *estk[20] = {0};
int sptr = 0;
int cptr = 0;
int pptr = 0;
int eptr = 0;
pushstk();
popstk();
char *EOLS = "\n";
char *NULSTG = "";
char *FR = "\\fR";
%}
LB	[ \t]*[\133{(]
RB	[\135})\n]
%e 2000
%p 6000
%n 1000
%START ITEM ENUM
%%
\\				{printf("\\e");}
"\\input"			{printf(".CO %s",yytext);}
\n\n"  "			{printf("\n.pp\n");}
\n\n/[A-Za-z]			{printf("\n.lp\n");}
"@@"				{printf("@");}
"@."				{printf(".");}
\006"9"				{printf("\\s+8");}
\006"*"				{printf("\\s-8");}
".el"				{printf("\\&.el");}
".signature"			{printf("\\&%s",yytext);}
"@menu"				{printf(".ig I1");}
"@end menu"			{printf(".I1");}
"@ignore"			{printf(".ig I2");}
"@end ignore"			{printf(".I2");}
"@info"				{printf(".ig I3");}
"@end info"			{printf(".I3");}
"@node".*$			{printf(".CO %s",yytext);}
"@tex"				{printf(".ig I4");}
"@end tex"			{printf(".I4");}
"@ifinfo"			{printf(".ig I5");}
"@end ifinfo"			{printf(".I5");}"
"@example"			{printf(".(l");}
"@end example"			{printf(".)l\n.sp \\n(psu");}
"@quotation"			{printf(".(q");}
"@end quotation"		{printf(".)q");}
"@format"			{printf(".(q");}
"@end format"			{printf(".)q");}
"@dots"				{printf("...");}
"@bullet"			{printf("\\(bu");}
{RB}				{popstk(*yytext);}
"@code"{LB}			{printf("\\f3"); pushstk(yytext,FR);}
"@kbd"{LB}			{printf("\\f3"); pushstk(yytext,FR);}
"@ctl"{LB}			{printf("\\f3"); pushstk(yytext,FR);}
"@dfn"{LB}			{printf("\\f3"); pushstk(yytext,FR);}
"@key"{LB}			{printf("\\f3"); pushstk(yytext,FR);}
"@samp"{LB}			{printf("\\f3"); pushstk(yytext,FR);}
"@var"{LB}			{printf("\\fI"); pushstk(yytext,FR);}
"@i"{LB}			{printf("\\fI"); pushstk(yytext,FR);}
"@b"{LB}			{printf("\\fB"); pushstk(yytext,FR);}
"@w"{LB}			{pushstk(yytext,NULSTG);}
"@ttfont"{LB}			{pushstk(yytext,NULSTG);}
"@c ".*$			{printf(".CO %s",yytext+2);}
"@comment".*$			{printf(".CO %s",yytext+8);}
"@iftex"			{printf(".CO");}
"@end iftex"			{printf(".CO");}
"@unnumberedsec "		{printf(".uh \"");pushstk(EOLS,"\"\n.sp \\npsu\n");}
"@unnumberedsec"{LB}		{printf(".uh \"");pushstk(yytext,"\"\n.sp \\npsu\n");}
"@display"			{printf(".(c\n.(l");}
"@end display"			{printf(".)l\n.)c");}
"@begin"{LB}			{printf(".CO ");pushstk(yytext,NULSTG);}
"@end description"		{printf(".CO %s",yytext);}
"@page"				{printf(".bp");}
"@TeX"				{printf("TeX");}
"@section"{LB}			{printf(".sh 1 \"");pushstk(yytext,"\"");}
"@section "			{printf(".sh 1 \"");pushstk(EOLS,"\"");}
"@unnumbered"{LB}		{printf(".uh \"");pushstk(yytext,"\"");}
"@unnumbered "			{printf(".CO %s",yytext);}
"@summarycontents"		{printf(".CO %s",yytext);}
"@contents"			{printf(".CO %s",yytext);}
"@bye"				{printf(".CO %s",yytext);}
"@subsection "			{printf(".sh 2 \"");pushstk(EOLS,"\"\n");}
"@subsection"{LB}		{printf(".sh 2 \"");pushstk(yytext,"\"\n");}
"@table "			{printf(".ba +");}
"@end table"			{printf(".ba\n.lp");}
"@exdent 1 "			{printf(".ti 0\n");}
"@item "			{printf(".ip \"");pushstk(EOLS,"\" 10\n");}
"@itemx "			{printf(".ip \"");pushstk(EOLS,"\" 10\n");}
"@itemize"			{printf(".ds IC"); BEGIN ITEM;}
<ITEM>"@item"$			{printf(".ip \\*(IC");}
"@end itemize"			{printf(".rm IC"); BEGIN 0;}
"@enumerate"			{printf(".nr $p 0"); BEGIN ENUM;}
<ENUM>"@item"$			{printf(".np");}
"@end enumerate"		{printf(".nr $p 0"); BEGIN 0;}
"@vindex"{LB}			{printf(".tm %s ",yytext);pushstk(yytext,"\t\\n%");}
"@cfindex"{LB}			{printf(".tm %s ",yytext);pushstk(yytext,"\t\\n%");}
"@cindex"{LB}			{printf(".tm %s ",yytext);pushstk(yytext,"\t\\n%");}
"@findex"{LB}			{printf(".tm %s ",yytext);pushstk(yytext,"\t\\n%");}
"@kindex"{LB}			{printf(".tm %s ",yytext);pushstk(yytext,"\t\\n%");}
"@printindex"			{printf(".CO %s",yytext);}
"@chapter"{LB}			{printf(".+c \"");pushstk(yytext,"\"");}
"@chapter"			{printf(".+c \"");pushstk(EOLS,"\"");}
"@xref"{LB}			{printf("See ");pushstk(yytext,NULSTG);}
"@nopara"			{printf(".CO nopara");}
"@pxref"{LB}			{printf("See ");pushstk(yytext,NULSTG);}
"@sp"				{printf(".sp");}
"@center"[ \t]*			{printf(".ce 1\n");}
"@setref"			{printf(".SR");}
"@lisp"				{printf(".(q");}
"@end lisp"			{printf(".)q");}
"@settitle"{LB}			{printf(".he ''");pushstk(yytext,"'%'");}
"@setchapternewpage"		{printf(".CO %s",yytext);}
"@headings"			{printf(".CO %s",yytext);}
"@refill"			{/* do nothing */}
"@include"			{printf(".CO %s",yytext);}
"@include ggloss.tex"		{printf(".so ggloss.tr");}
"@lispnarrowing"		{printf(".CO %s",yytext);}
"@tableindent"			{printf(".CO %s",yytext);}
"@itemindent"			{printf(".CO %s",yytext);}
"@baselineskip"			{printf(".CO %s",yytext);}
"@aboveenvskipamount"		{printf(".CO %s",yytext);}
"@parskip"			{printf(".CO %s",yytext);}
"@parindent"			{printf(".CO %s",yytext);}
"@hsize"			{printf(".CO %s",yytext);}
"@defindex"			{printf(".CO %s",yytext);}
"@kern"				{printf(".CO %s",yytext);}
%%
char *
substr(s,i)
char *s;
int i;

{
    s[strlen(s)-1] = '\0';
    return(s+i);
}

pushstk(c,s)
char c[],*s;

{
    switch(c[strlen(c)-1]) {
	case '[': sstk[sptr++] = s;
		  break;
	case '{': cstk[cptr++] = s;
		  break;
	case '(': pstk[pptr++] = s;
		  break;
	case '\n':estk[eptr++] = s;
		  break;
    }
}

popstk(c)
char c;

{
    switch(c) {
	case ']': if (sptr <= 0)
		      printf("]");
		  else
		      printf("%s",sstk[--sptr]);
		  break;
	case '}': if (cptr <= 0)
		      printf("}");
		  else
		      printf("%s",cstk[--cptr]);
		  break;
	case ')': if (pptr <= 0)
		      printf(")");
		  else
		      printf("%s",pstk[--pptr]);
		  break;
	case '\n':if (eptr <=0)
		      printf("\n");
		  else
		      printf("%s",estk[--eptr]);
		  break;
    }
}
/* -*- C -*- */
