/* ByteVect.c -- Data type-specific functions for class ByteVec

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
        Ted Persky
	Bg. 12A, Rm. 2031
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-2963
	uucp: uunet!nih-csl!ted

Function:
	
Data type -specific functions for class ShortVec.

Modification History:

$Log:	ByteVect.c,v $
 * Revision 2.204  89/10/08  09:42:36  keith
 * Pre-release
 * 
 * Revision 2.203  89/08/22  09:17:03  ted
 * Pre-release
 * 
 * Revision 2.203  89/08/14  11:30:21  ted
 * New programs for this rev
 * 
	
*/

#include "ByteVec.h"
#include "nihclconfig.h"
#include "nihclIO.h"
#include <libc.h>

#define	THIS	ByteVec
#define	BASE	Vector

static int typeCmp(const void* a, const void* b)
{
	return *(const int*)a-*(const int*)b;
}

void THIS::sort()
{
	qsort(v,n,sizeof(THIS),typeCmp);
}

unsigned THIS::hash() const
{
	unsigned h = n;
	unsigned i = n;
	bytevecbyte* vv = v;
	while (i--) h ^= (unsigned)*vv++;
	return h;
}

void THIS::printOn(ostream& strm) const
{
	for (int i=0; i<n; i++) {
		if (i>0 && (i%8 == 0)) strm << "\n\t";
		strm << dec(v[i],10);
	}
}

void THIS::scanFrom(istream& strm)
{
	extern const int NIHCL_NYET;
	setError(NIHCL_NYET,DEFAULT,className(),"scanFrom");
}
